//
//  SOMAMoPubMultiFormatInterstitialAdapter.m
//  Smaato
//
//  Copyright (c) 2018 Smaato Inc. All rights reserved.
//

#import <iSoma/iSoma.h>
#import "SOMAMoPubMultiFormatInterstitialAdapter.h"
#import "MoPub.h"

@interface SOMAMoPubMultiFormatInterstitialAdapter ()<SOMAAdViewDelegate>
@property (nonatomic) SOMAMultiFormatInterstitial* interstitialAdView;
@end

@implementation SOMAMoPubMultiFormatInterstitialAdapter
-(void)requestInterstitialWithCustomEventInfo:(NSDictionary *)info {
    
    // Create ad container
    self.interstitialAdView = [[SOMAMultiFormatInterstitial alloc] init];
    self.interstitialAdView.delegate = self;

    // Apply ad settings
    self.interstitialAdView.adSettings.type = SOMAAdTypeInterstitial;
    self.interstitialAdView.adSettings.autoReloadEnabled = NO;
    
    [self extractPublisherAndAdSpaceIDFromParameters:info];

    // Optional: Pass location information
    CLLocation* location =  [self.delegate location];
    if (location) {
        self.interstitialAdView.adSettings.longitude = location.coordinate.longitude;
        self.interstitialAdView.adSettings.latitude = location.coordinate.latitude;
    }
    
    // Optional: You can also set user profile targeting parameters by updating the `adView.adSettings.userProfile` object.
    // Please check the Smaato wiki for all available properties and further details.

    dispatch_async(dispatch_get_main_queue(), ^{
        [self.interstitialAdView load];
    });
}

- (void)extractPublisherAndAdSpaceIDFromParameters:(NSDictionary*)parameters {
    if ([[parameters allKeys] containsObject:@"pub"]) {
        self.interstitialAdView.adSettings.publisherId=[parameters[@"pub"] intValue];
    } else if ([[parameters allKeys] containsObject:@"publisher"]) {
        self.interstitialAdView.adSettings.publisherId=[parameters[@"publisher"] intValue];
    } else if ([[parameters allKeys] containsObject:@"publisherid"]) {
        self.interstitialAdView.adSettings.publisherId=[parameters[@"publisherid"] intValue];
    } else if ([[parameters allKeys] containsObject:@"publisherId"]) {
        self.interstitialAdView.adSettings.publisherId=[parameters[@"publisherId"] intValue];
    } else if ([[parameters allKeys] containsObject:@"PublisherId"]) {
        self.interstitialAdView.adSettings.publisherId=[parameters[@"PublisherId"] intValue];
    } else if ([[parameters allKeys] containsObject:@"PublisherID"]) {
        self.interstitialAdView.adSettings.publisherId=[parameters[@"PublisherID"] intValue];
    } else if ([[parameters allKeys] containsObject:@"publisherID"]) {
        self.interstitialAdView.adSettings.publisherId=[parameters[@"publisherID"] intValue];
    } else if ([[parameters allKeys] containsObject:@"Publisher"]) {
        self.interstitialAdView.adSettings.publisherId=[parameters[@"Publisher"] intValue];
    }
    
    if ([[parameters allKeys] containsObject:@"ad"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"ad"] intValue];
    } else if ([[parameters allKeys] containsObject:@"adspace"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"adspace"] intValue];
    } else if ([[parameters allKeys] containsObject:@"adspaceid"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"adspaceid"] intValue];
    } else if ([[parameters allKeys] containsObject:@"adspaceId"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"adspaceId"] intValue];
    } else if ([[parameters allKeys] containsObject:@"AdspaceId"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"AdspaceId"] intValue];
    } else if ([[parameters allKeys] containsObject:@"AdspaceID"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"AdspaceID"] intValue];
    } else if ([[parameters allKeys] containsObject:@"adspaceID"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"adspaceID"] intValue];
    } else if ([[parameters allKeys] containsObject:@"AdSpaceID"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"AdSpaceID"] intValue];
    } else if ([[parameters allKeys] containsObject:@"AdSpaceId"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"AdSpaceId"] intValue];
    } else if ([[parameters allKeys] containsObject:@"AdSpace"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"AdSpace"] intValue];
    } else if ([[parameters allKeys] containsObject:@"Ad"]) {
        self.interstitialAdView.adSettings.adSpaceId=[parameters[@"Ad"] intValue];
    }
}

-(void)showInterstitialFromRootViewController:(UIViewController *)rootViewController {
    if ([self.interstitialAdView isReady]) {
        [self.interstitialAdView show:rootViewController];
    }
}

#pragma mark - SOMAAdViewDelegate
-(UIViewController*)somaRootViewController {
    return nil;
}

-(void)somaAdViewWillLoadAd:(SOMAAdView *)adview {

}

-(void)somaAdViewDidLoadAd:(SOMAAdView *)adview {
    if ([self.delegate respondsToSelector:@selector(interstitialCustomEvent:didLoadAd:)]) {
        [self.delegate interstitialCustomEvent:self didLoadAd:nil];
    }
}

-(void)somaAdView:(SOMAAdView *)adview didFailToReceiveAdWithError:(NSError *)error {
    if ([self.delegate respondsToSelector:@selector(interstitialCustomEvent:didFailToLoadAdWithError:)]) {
        [self.delegate interstitialCustomEvent:self didFailToLoadAdWithError:error];
    }
}

-(void)somaAdViewDidClick:(SOMAAdView *)adview {
    if ([self.delegate respondsToSelector:@selector(interstitialCustomEventDidReceiveTapEvent:)]) {
        [self.delegate interstitialCustomEventDidReceiveTapEvent:self];
    }
}

-(void)somaAdViewWillEnterFullscreen:(SOMAAdView *)adview {
    if ([self.delegate respondsToSelector:@selector(interstitialCustomEventWillAppear:)]) {
        [self.delegate interstitialCustomEventWillAppear:self];
    }
}

-(void)somaAdViewDidEnterFullscreen:(SOMAAdView *)adview {
    if ([self.delegate respondsToSelector:@selector(interstitialCustomEventDidAppear:)]) {
        [self.delegate interstitialCustomEventDidAppear:self];
    }
}

-(void)somaAdViewWillExitFullscreen:(SOMAAdView *)adview {
    if ([self.delegate respondsToSelector:@selector(interstitialCustomEventWillDisappear:)]) {
        [self.delegate interstitialCustomEventWillDisappear:self];
    }
}

-(void)somaAdViewDidExitFullscreen:(SOMAAdView *)adview {
    if ([self.delegate respondsToSelector:@selector(interstitialCustomEventDidDisappear:)]) {
        [self.delegate interstitialCustomEventDidDisappear:self];
    }
    if (adview == self.interstitialAdView) {
        [self.interstitialAdView removeFromSuperview];
        self.interstitialAdView.delegate = nil;
        self.interstitialAdView = nil;
    }
}

-(void)somaAdViewWillLeaveApplicationFromAd:(SOMAAdView *)adView {
    if ([self.delegate respondsToSelector:@selector(interstitialCustomEventWillLeaveApplication:)]) {
        [self.delegate interstitialCustomEventWillLeaveApplication:self];
    }
}

@end
